from loguru import logger


# context
#   boxes: structure of boxes
#   client: MQTT client
#
# boxes['box_name']['context']
#   store here what ever is require to represent the state of the box

def process_message(box_name, topic_key, payload, context):
    try:
        logger.info(f"[{box_name}] Processing message for '{topic_key}': {payload}")

        match topic_key.split('/'):
            case [ primary_key, sub_key ] if primary_key == 'window':
                pass
            case [ primary_key ] if primary_key == 'high_temp':
                pass
            case [ primary_key ] if primary_key == 'cmd':
                pass
            case [ primary_key ] if primary_key == 'general_off':
                pass
            case [ primary_key ] if primary_key == 'maintenance_mode':
                pass
            case _:
                raise Error(f"Unexcepted topic_key: {topic_key}, {payload}") 

        # Example processing: Implement your specific logic here
        # For example, perform calculations or store data.
        result = f"Processed by {box_name} for '{topic_key}': {payload}"

        publish_topic = f"{context['publish']}/{box_name}"
        context['client'].publish(publish_topic, result)
        logger.info(f"[{box_name}] Result published on '{publish_topic}': {result}")
    except Exception as e:
        logger.error(f"[{box_name}] Error processing '{topic_key}': {e}") 
